<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0"> 
    <title>flask-socketio</title>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/socket.io/4.0.1/socket.io.js" integrity="sha512-q/dWJ3kcmjBLU4Qc47E4A9kTB4m3wuTY7vkFJDTZKjTs8jhyGQnaUrxa0Ytd0ssMZhbNua9hE+E7Qv1j+DyZwA==" crossorigin="anonymous"></script>
  </head>
  <body>
    <button id="inicio">Iniciar</button>
    <audio src="" id="audio" autoplay="true"></audio>
    <script>
      const socket = io()

      socket.on('connect', function(){ //evento reservado
        console.log("Conectado")
      });

      socket.on('voz', (arg)=>{
        console.log(arg)
        var utterance  = new SpeechSynthesisUtterance()
        utterance.volume = 1
        utterance.rate = 0.8
        utterance.pitch = 0.3
        utterance.text = arg
        speechSynthesis.speak(utterance)
      });

      socket.on('grabar', ()=>{
        var flag_usuario = 0
        navigator.mediaDevices.getUserMedia({audio: true, video: false}).then((stream)=>{
          console.log(stream)

          const mediaRecorder = new MediaRecorder(stream)
          mediaRecorder.start()
          console.log(mediaRecorder.state);

          let chunks = [];
          mediaRecorder.ondataavailable = (e) => {
            chunks.push(e.data);
          };

          setTimeout(() => {
            //parar grabación
            mediaRecorder.stop();
            if (mediaRecorder.state == 'inactive'){
              console.log(mediaRecorder.state)
              mediaRecorder.onstop = (e) => {
                const blob = new Blob(chunks, { type: "audio/webm; codecs=opus" });
                socket.emit('escuchar', blob);
                //socket.emit('event', blob, 0, 0, 1);
                flag_usuario = 1
                flag_record = 1
              };
            };
          }, 5000);

        }).catch((err)=>console.log(err))

      });

      let imagen = 0
      socket.on('diagrama', (size)=>{
        //const imagen = document.createElement("img")
        if (size['borrar'] == 0){
          //const imagen = document.createElement("img")
          imagen = document.createElement("img")
          let binaryData = []
          binaryData.push(size['image_data'])
          img_url = window.URL.createObjectURL(new Blob(binaryData, {type: "bpm.png"}))
          imagen.src = img_url
          imagen.height = size['height']
          imagen.width = size['width']
          imagen.alt = "bpm"
          document.body.appendChild(imagen)
        };
        if (size['borrar'] == 1){
          document.body.removeChild(imagen)
        };
        //document.body.removeChild(imagen)
      });

      socket.on('disconnect', function(){ //evento reservado
        console.log("Desconectado")
      });

      const boton_inicio = document.getElementById("inicio");

      boton_inicio.addEventListener("click", (event)=>{
        socket.emit('event')
      });

    </script>
    <h1>Wizard</h1>
  </body>
</html>